/*
  divisors.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

void cout_divisors(const mpz_class n)
{
  mpz_class d(1), sqrt_n;

  mpz_sqrt(sqrt_n.get_mpz_t(), n.get_mpz_t());
  for (; d<=sqrt_n; ++d)
    if (n%d == 0) {
      std::cout << d << "\t";
      if (d != n/d) std::cout << n/d << "\t";
    }
  std::cout << std::endl;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " number [...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a)
    cout_divisors(mpz_class(argv[a]));
  
  return 0;
}
