/*
  factorize.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <sstream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

void cout_factorize(mpz_class n)
{
  mpz_class f(2), c;

  std::cout << n << "\t";
  if (n == 1) std::cout << 1 << "^" << 0 << "\t";
  for (; f <= n; mpz_nextprime(f.get_mpz_t(), f.get_mpz_t())) {
    c = 0;
    while (n % f == 0) {
      ++c;
      n /= f;
    }
    if (c > 0) std::cout << f << "^" << c << "\t";
  }
  std::cout << std::endl;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = argv[a];
    cout_factorize(n);
  }
  return 0;
}
