/*
  n_primes.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [-l lower] [-c count]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n, l(1), c(100), i;

  for (a=1; a<argc; ++a)
    if (std::string(argv[a]) == "-h")
      return usage(std::cout, argc, argv);
    else if (std::string(argv[a]) == "-l" && a+1 < argc)
      l = argv[++a];
    else if (std::string(argv[a]) == "-c" && a+1 < argc)
      c = argv[++a];
    else
      break;

  mpz_nextprime(n.get_mpz_t(), l.get_mpz_t());
  for (i=0; i<c; mpz_nextprime(n.get_mpz_t(), n.get_mpz_t()), ++i)
    std::cout << n << std::endl;

  return 0;
}
