/*
  previous_prime.cc

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <iostream>
#include <string>
#include <libgen.h>
#include <gmpxx.h>

inline
void mpz_previousprime(mpz_t rop, const mpz_t op)
{
  mpz_sub_ui(rop, op, 1);
  for (; mpz_cmp_ui(rop, 0) > 0; mpz_sub_ui(rop, rop, 1))
    if (mpz_probab_prime_p(rop, 25))
      break;
}

int usage(std::ostream &os, int argc, char *argv[])
{
  (void)argc;
  os << "Usage:\n\t" << basename(argv[0]) << " [number ...]\n";
  return os == std::cerr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;
  mpz_class n;

  if (argc < 2) return usage(std::cerr, argc, argv);
  for (a=1; a<argc; ++a) {
    n = argv[a];
    if (argc > 2) std::cout << n << "\t";
    mpz_previousprime(n.get_mpz_t(), n.get_mpz_t());
    if (mpz_cmp_ui(n.get_mpz_t(), 0) != 0)
      std::cout << n << std::endl;
    else
      std::cout << "NaN" << std::endl;
  }

  return 0;
}
